/*
 * RSSBot
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.rssbot.util

import java.time.ZonedDateTime
import java.time.format.DateTimeFormatter
import java.time.format.DateTimeParseException


object TimeUtil {
    fun getUnixTimeFromStamp(input: String): Long { // Pattern: Sun, 15 Oct 2023 11:04:57 GMT
        try {
            val formatter = DateTimeFormatter.ofPattern("EEE, dd MMM yyyy HH:mm:ss zzz")
            val result = ZonedDateTime.parse(input, formatter).toEpochSecond() * 1000
            Logger.out("Converted $input to $result")
            return result
        } catch (e: DateTimeParseException) {
            Logger.out("Could not convert $input to unix time, trying other pattern")
            return try {
                val formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ssX")
                val result = ZonedDateTime.parse(input, formatter).toEpochSecond() * 1000
                Logger.out("Converted $input to $result")
                result
            } catch (e: DateTimeParseException) {
                Logger.out("Could not convert $input to unix time")
                0
            }
        }
    } // I'm ashamed of this code. I'm sorry. I don't know how to do it better.
}
